/***************************************************************************
 *   Copyright (C) 2010 by Martin Burgemeister, Mathis Lindemann           *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef UCQDETAILS_H
#define UCQDETAILS_H

#include <QtGui/QWidget>
#include "ui_ucdetails.h"
#include "data/Letter.h"
#include "data/TableModel.h"
#include <QMouseEvent>

/**
 * \class UCQDetails
 * \brief Small "mouse-over-widget" to display details of letters in the
 *        UCQTableView.
 *
 * \author Martin Burgemeister <Martin.Burgemeister@gmx.de>,
 *         Mathis Lindemann <MathisLindemann@gmx.net>
 * \version 1.0
 * \date 16 August 2010
 *
 * \see TableModel
 * \see Letter
 */
class UCQDetails: public QWidget
{

Q_OBJECT

public:
    UCQDetails ( QWidget* = 0, TableModel* = 0 );

    void setTableModel ( TableModel* );

private:
    void prepareLabels ( Letter* );
    /**
     * \brief Ui object.
     */
    Ui::UCQDetails ui_;
    /**
     * \brief TableModel instance to get the info for the letters.
     */
    TableModel* tableModel_;

protected slots:
    void changeStatus ( QMouseEvent* );
    void move ( int, int );
    void changeLetter ( QModelIndex );
    void setFont ( const QFont& );
};

#endif // UCQDETAILS_H
